com.fasterxml.jackson.databind.ser.std

## Class EnumMapSerializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonSerializer<T>
  - - com.fasterxml.jackson.databind.ser.std.StdSerializer<T>
    - - com.fasterxml.jackson.databind.ser.ContainerSerializer<EnumMap<? extends Enum<?>,?>>
      - - com.fasterxml.jackson.databind.ser.std.EnumMapSerializer

All Implemented Interfaces:
  JsonFormatVisitable, SchemaAware, ContextualSerializer, Serializable

Deprecated.
Since 2.4.4; standard `MapSerializer` works better. (to be removed from 2.6)

    @Deprecated
    public class EnumMapSerializer
    extends ContainerSerializer<EnumMap<? extends Enum<?>,?>>
    implements ContextualSerializer

Specialized serializer for `EnumMap`s. Somewhat tricky to implement because actual Enum value type may not be available; and if not, it can only be gotten from actual instance.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonSerializer

`JsonSerializer.None`

### Field Summary

Fields
`protected EnumValues` `_keyEnums` Deprecated. If we know enumeration used as key, this will contain value set to use for serialization
`protected BeanProperty` `_property` Deprecated. Property for which this serializer is being used, if any; null for root values.
`protected boolean` `_staticTyping` Deprecated.
`protected JsonSerializer<Object>` `_valueSerializer` Deprecated. Value serializer to use, if it can be statically determined
`protected JavaType` `_valueType` Deprecated.
`protected TypeSerializer` `_valueTypeSerializer` Deprecated. Type serializer used for values, if any.

### Fields inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

`_handledType`

### Constructor Summary

Constructors
Constructor and Description
`EnumMapSerializer(EnumMapSerializer src, BeanProperty property, JsonSerializer<?> ser)` Deprecated. Constructor called when a contextual instance is created.
`EnumMapSerializer(JavaType valueType, boolean staticTyping, EnumValues keyEnums, TypeSerializer vts, JsonSerializer<Object> valueSerializer)` Deprecated.

### Method Summary

Methods
`EnumMapSerializer` `_withValueTypeSerializer(TypeSerializer vts)` Deprecated. Method that needs to be implemented to allow construction of a new serializer object with given `TypeSerializer`, used when addition type information is to be embedded.
`void` `acceptJsonFormatVisitor(JsonFormatVisitorWrapper visitor, JavaType typeHint)` Deprecated. We consider possibility here that an EnumMap might actually just be serialized as something like a Record, given that number of keys is bound, just like with Objects/Records (and not unbounded like regular maps)
`JsonSerializer<?>` `createContextual(SerializerProvider provider, BeanProperty property)` Deprecated. Method called to see if a different (or differently configured) serializer is needed to serialize values of specified property.
`JsonSerializer<?>` `getContentSerializer()` Deprecated. Accessor for serializer used for serializing contents (List and array elements, Map values etc) of the container for which this serializer is used, if it is known statically.
`JavaType` `getContentType()` Deprecated. Accessor for finding declared (static) element type for type this serializer is used for.
`JsonNode` `getSchema(SerializerProvider provider, Type typeHint)` Deprecated. Default implementation simply claims type is "string"; usually overriden by custom serializers.
`boolean` `hasSingleElement(EnumMap<? extends Enum<?>,?> value)` Deprecated. Method called to determine if the given value (of type handled by this serializer) contains exactly one element.
`boolean` `isEmpty(EnumMap<? extends Enum<?>,?> value)` Deprecated. Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).
`void` `serialize(EnumMap<? extends Enum<?>,?> value, com.fasterxml.jackson.core.JsonGenerator jgen, SerializerProvider provider)` Deprecated. Method that can be called to ask implementation to serialize values of type this serializer handles.
`protected void` `serializeContents(EnumMap<? extends Enum<?>,?> value, com.fasterxml.jackson.core.JsonGenerator jgen, SerializerProvider provider)` Deprecated.
`protected void` `serializeContentsUsing(EnumMap<? extends Enum<?>,?> value, com.fasterxml.jackson.core.JsonGenerator jgen, SerializerProvider provider, JsonSerializer<Object> valueSer)` Deprecated.
`void` `serializeWithType(EnumMap<? extends Enum<?>,?> value, com.fasterxml.jackson.core.JsonGenerator jgen, SerializerProvider provider, TypeSerializer typeSer)` Deprecated. Method that can be called to ask implementation to serialize values of type this serializer handles, using specified type serializer for embedding necessary type information.
`EnumMapSerializer` `withValueSerializer(BeanProperty prop, JsonSerializer<?> ser)` Deprecated.

### Methods inherited from class com.fasterxml.jackson.databind.ser.ContainerSerializer

`hasContentTypeAnnotation, withValueTypeSerializer`

### Methods inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

`createObjectNode, createSchemaNode, createSchemaNode, findConvertingContentSerializer, findPropertyFilter, getSchema, handledType, isDefaultSerializer, wrapAndThrow, wrapAndThrow`

### Methods inherited from class com.fasterxml.jackson.databind.JsonSerializer

`getDelegatee, isEmpty, isUnwrappingSerializer, replaceDelegatee, unwrappingSerializer, usesObjectId`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### _staticTyping

    protected final boolean _staticTyping

Deprecated.

#### _property

    protected final BeanProperty _property

Deprecated.
Property for which this serializer is being used, if any; null for root values.

#### _keyEnums

    protected final EnumValues _keyEnums

Deprecated.
If we know enumeration used as key, this will contain value set to use for serialization

#### _valueType

    protected final JavaType _valueType

Deprecated.

#### _valueSerializer

    protected final JsonSerializer<Object> _valueSerializer

Deprecated.
Value serializer to use, if it can be statically determined

#### _valueTypeSerializer

    protected final TypeSerializer _valueTypeSerializer

Deprecated.
Type serializer used for values, if any.

### Constructor Detail

#### EnumMapSerializer

    public EnumMapSerializer(JavaType valueType,
                     boolean staticTyping,
                     EnumValues keyEnums,
                     TypeSerializer vts,
                     JsonSerializer<Object> valueSerializer)

Deprecated.

#### EnumMapSerializer

    public EnumMapSerializer(EnumMapSerializer src,
                     BeanProperty property,
                     JsonSerializer<?> ser)

Deprecated.
Constructor called when a contextual instance is created.

### Method Detail

#### _withValueTypeSerializer

    public EnumMapSerializer _withValueTypeSerializer(TypeSerializer vts)

Deprecated.
Description copied from class: `ContainerSerializer`
Method that needs to be implemented to allow construction of a new serializer object with given `TypeSerializer`, used when addition type information is to be embedded.

Specified by:
  `_withValueTypeSerializer` in class `ContainerSerializer<EnumMap<? extends Enum<?>,?>>`

#### withValueSerializer

    public EnumMapSerializer withValueSerializer(BeanProperty prop,
                                        JsonSerializer<?> ser)

Deprecated.

#### createContextual

    public JsonSerializer<?> createContextual(SerializerProvider provider,
                                     BeanProperty property)
                                       throws JsonMappingException

Deprecated.
Description copied from interface: `ContextualSerializer`
Method called to see if a different (or differently configured) serializer is needed to serialize values of specified property. Note that instance that this method is called on is typically shared one and as a result method should NOT modify this instance but rather construct and return a new instance. This instance should only be returned as-is, in case it is already suitable for use.

Specified by:
  `createContextual` in interface `ContextualSerializer`
Parameters:
  `provider` - Serializer provider to use for accessing config, other serializers
  `property` - Method or field that represents the property (and is used to access value to serialize). Should be available; but there may be cases where caller can not provide it and null is passed instead (in which case impls usually pass 'this' serializer as is)
Returns:
  Serializer to use for serializing values of specified property; may be this instance or a new instance.
Throws:
  `JsonMappingException`

#### getContentType

    public JavaType getContentType()

Deprecated.
Description copied from class: `ContainerSerializer`
Accessor for finding declared (static) element type for type this serializer is used for.

Specified by:
  `getContentType` in class `ContainerSerializer<EnumMap<? extends Enum<?>,?>>`

#### getContentSerializer

    public JsonSerializer<?> getContentSerializer()

Deprecated.
Description copied from class: `ContainerSerializer`
Accessor for serializer used for serializing contents (List and array elements, Map values etc) of the container for which this serializer is used, if it is known statically. Note that for dynamic types this may return null; if so, caller has to instead use `ContainerSerializer.getContentType()` and `SerializerProvider.findValueSerializer(java.lang.Class<?>, com.fasterxml.jackson.databind.BeanProperty)`.

Specified by:
  `getContentSerializer` in class `ContainerSerializer<EnumMap<? extends Enum<?>,?>>`

#### isEmpty

    public boolean isEmpty(EnumMap<? extends Enum<?>,?> value)

Deprecated.
Description copied from class: `JsonSerializer`
Method called to check whether given serializable value is considered "empty" value (for purposes of suppressing serialization of empty values).

Default implementation will consider only null values to be empty.

Specified by:
  `isEmpty` in class `ContainerSerializer<EnumMap<? extends Enum<?>,?>>`

#### hasSingleElement

    public boolean hasSingleElement(EnumMap<? extends Enum<?>,?> value)

Deprecated.
Description copied from class: `ContainerSerializer`
Method called to determine if the given value (of type handled by this serializer) contains exactly one element.

Note: although it might seem sensible to instead define something like "getElementCount()" method, this would not work well for containers that do not keep track of size (like linked lists may not).

Specified by:
  `hasSingleElement` in class `ContainerSerializer<EnumMap<? extends Enum<?>,?>>`

#### serialize

    public void serialize(EnumMap<? extends Enum<?>,?> value,
                 com.fasterxml.jackson.core.JsonGenerator jgen,
                 SerializerProvider provider)
                   throws IOException,
                          com.fasterxml.jackson.core.JsonGenerationException

Deprecated.
Description copied from class: `JsonSerializer`
Method that can be called to ask implementation to serialize values of type this serializer handles.

Specified by:
  `serialize` in class `StdSerializer<EnumMap<? extends Enum<?>,?>>`
Parameters:
  `value` - Value to serialize; can not be null.
  `jgen` - Generator used to output resulting Json content
  `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
Throws:
  `IOException`
  `com.fasterxml.jackson.core.JsonGenerationException`

#### serializeWithType

    public void serializeWithType(EnumMap<? extends Enum<?>,?> value,
                         com.fasterxml.jackson.core.JsonGenerator jgen,
                         SerializerProvider provider,
                         TypeSerializer typeSer)
                           throws IOException,
                                  com.fasterxml.jackson.core.JsonGenerationException

Deprecated.
Description copied from class: `JsonSerializer`
Method that can be called to ask implementation to serialize values of type this serializer handles, using specified type serializer for embedding necessary type information.

Default implementation will throw `UnsupportedOperationException` to indicate that proper type handling needs to be implemented.

For simple datatypes written as a single scalar value (JSON String, Number, Boolean), implementation would look like:

      // note: method to call depends on whether this type is serialized as JSON scalar, object or Array!
      typeSer.writeTypePrefixForScalar(value, gen);
      serialize(value, gen, provider);
      typeSer.writeTypeSuffixForScalar(value, gen);

and implementations for type serialized as JSON Arrays or Objects would differ slightly, as `START-ARRAY>/`END-ARRAY` and `START-OBJECT>/`END-OBJECT` pairs need to be properly handled with respect to serializing of contents.``

Overrides:
  `serializeWithType` in class `JsonSerializer<EnumMap<? extends Enum<?>,?>>`
Parameters:
  `value` - Value to serialize; can not be null.
  `jgen` - Generator used to output resulting Json content
  `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
  `typeSer` - Type serializer to use for including type information
Throws:
  `IOException`
  `com.fasterxml.jackson.core.JsonGenerationException`

#### serializeContents

    protected void serializeContents(EnumMap<? extends Enum<?>,?> value,
                         com.fasterxml.jackson.core.JsonGenerator jgen,
                         SerializerProvider provider)
                              throws IOException,
                                     com.fasterxml.jackson.core.JsonGenerationException

Deprecated.

Throws:
  `IOException`
  `com.fasterxml.jackson.core.JsonGenerationException`

#### serializeContentsUsing

    protected void serializeContentsUsing(EnumMap<? extends Enum<?>,?> value,
                              com.fasterxml.jackson.core.JsonGenerator jgen,
                              SerializerProvider provider,
                              JsonSerializer<Object> valueSer)
                                   throws IOException,
                                          com.fasterxml.jackson.core.JsonGenerationException

Deprecated.

Throws:
  `IOException`
  `com.fasterxml.jackson.core.JsonGenerationException`

#### getSchema

    public JsonNode getSchema(SerializerProvider provider,
                     Type typeHint)
                       throws JsonMappingException

Deprecated.
Description copied from class: `StdSerializer`
Default implementation simply claims type is "string"; usually overriden by custom serializers.

Specified by:
  `getSchema` in interface `SchemaAware`
Overrides:
  `getSchema` in class `StdSerializer<EnumMap<? extends Enum<?>,?>>`
Parameters:
  `provider` - The serializer provider.
  `typeHint` - A hint about the type.
Returns:
  Json-schema for this serializer.
Throws:
  `JsonMappingException`

#### acceptJsonFormatVisitor

    public void acceptJsonFormatVisitor(JsonFormatVisitorWrapper visitor,
                               JavaType typeHint)
                                 throws JsonMappingException

Deprecated.
We consider possibility here that an EnumMap might actually just be serialized as something like a Record, given that number of keys is bound, just like with Objects/Records (and not unbounded like regular maps)

Specified by:
  `acceptJsonFormatVisitor` in interface `JsonFormatVisitable`
Overrides:
  `acceptJsonFormatVisitor` in class `StdSerializer<EnumMap<? extends Enum<?>,?>>`
  `typeHint` - Type of element (entity like property) being visited
Throws:
  `JsonMappingException`